<template>
  <div class="container ms-0 mb-0">
    <div class="row">
      <div class="col mb-3">
        <el-form
          @validate="onValidate"
          :model="filter"
          :rules="rules"
          ref="filter-form"
          @submit.prevent=""
        >
          <el-form-item
            label="City name to filter"
            prop="name"
            @keyup.enter="submit"
          >
            <el-input v-model="filter.name" clearable />
          </el-form-item>
        </el-form>
      </div>
      <div class="col mb-3">
        <el-button :disabled="!isFormValid" type="primary" @click="submit">
          Apply
        </el-button>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { InputLength } from "@/validation";
import type { ElForm } from "element-plus";
import type { Filter } from "@/view/CityList.vue";

export default defineComponent({
  emits: ["update:cityFilter", "submit"],
  props: ["cityFilter"],
  data() {
    return {
      filter: {} as Filter,
      isFormValid: true,
      rules: {
        name: [new InputLength(255)],
      },
    };
  },
  async mounted() {
    this.filter = this.cityFilter;
  },
  methods: {
    submit() {
      const form = this.$refs["filter-form"] as InstanceType<typeof ElForm>;
      form.validate(async (valid) => {
        if (valid) {
          this.$emit("submit");
        }
      });
    },
    onValidate(prop: string, isVal: boolean) {
      this.isFormValid = isVal;
    },
    resetFilter() {
      this.filter = {} as Filter;
      this.$emit("update:cityFilter", this.filter);
      this.$emit("submit");
    },
  },
});
</script>
